import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface TieredCacheConfig extends cdktf.TerraformMetaArguments {
    /**
    * The typed of tiered cache to utilize on the zone. Available values: `generic`, `smart`, `off`.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/r/tiered_cache#cache_type TieredCache#cache_type}
    */
    readonly cacheType: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/r/tiered_cache#id TieredCache#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The zone identifier to target for the resource. **Modifying this attribute will force creation of a new resource.**
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/r/tiered_cache#zone_id TieredCache#zone_id}
    */
    readonly zoneId: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/cloudflare/r/tiered_cache cloudflare_tiered_cache}
*/
export declare class TieredCache extends cdktf.TerraformResource {
    static readonly tfResourceType = "cloudflare_tiered_cache";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/cloudflare/r/tiered_cache cloudflare_tiered_cache} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options TieredCacheConfig
    */
    constructor(scope: Construct, id: string, config: TieredCacheConfig);
    private _cacheType?;
    get cacheType(): string;
    set cacheType(value: string);
    get cacheTypeInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    get zoneIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
